#!/usr/bin/env python

# Glow Rel 1
# Created by Tin Tran (http://bakon.ca/gimplearn)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import math
#import string
#import Image
from gimpfu import *
#from array import array

def python_glow(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_selection_none(image)
	
	pdb.gimp_layer_resize_to_image_size(layer)
	
	#add black filled background
	pdb.gimp_context_set_default_colors()
	blacklayer = pdb.gimp_layer_new(image,layer.width,layer.height,RGBA_IMAGE,"black-filled",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(image,blacklayer,None,1)
	pdb.gimp_edit_fill(blacklayer,FOREGROUND_FILL)
	
	#make our layer white.
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,layer)
	pdb.gimp_edit_fill(layer,BACKGROUND_FILL)
	
	#adds outerglow layer
	outerglowlayer = pdb.gimp_layer_new(image,layer.width,layer.height,RGBA_IMAGE,"outer glow",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(image,outerglowlayer,None,1)
	pdb.gimp_selection_grow(image,3)
	pdb.gimp_context_set_foreground((0,126,255))
	pdb.gimp_edit_fill(outerglowlayer,FOREGROUND_FILL)
	pdb.gimp_selection_none(image)
	pdb.plug_in_gauss(image,outerglowlayer,45,45,1)
	
	#dodge outerglow copy
	outerglowcopy = pdb.gimp_layer_new_from_drawable(outerglowlayer,image)
	pdb.gimp_image_insert_layer(image,outerglowcopy,None,0)
	pdb.plug_in_gauss(image,outerglowcopy,30,30,1)
	pdb.gimp_layer_set_mode(outerglowcopy,DODGE_MODE)
	
	layercopy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layercopy,None,1)
	pdb.plug_in_gauss(image,layercopy,15,15,1)
	pdb.gimp_layer_set_mode(layercopy,DODGE_MODE)
	
	pdb.gimp_selection_none(image)

	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_glow",                           
	"Creates Glow Effect",
	"Creates Glow Effect",
	"Tin Tran",
	"Tin Tran",
	"May 2017",
	"<Image>/Python-Fu/Glow",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_SPINNER, "shift_pixels", "Shift Pixels:", 5, (1, 100, 1)),
	#(PF_COLOR, "oldcolor",  "Replace Color:",  (43,198,255)),
	#(PF_COLOR, "newcolor",  "With New Color:",  (255,198,0)),
	#(PF_SPINNER, "x1", "x1:", 0, (0, 100, 0.5)),
	#(PF_SPINNER, "y1", "y1:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "x2", "x2:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "y2", "y2:", 0, (0, 100, 0.5)),
	#(PF_COLOR, "black",  "Black point color",  (0,0,0) PF_FILE, "infilename", "Temp Filepath", "/Default/Path"),
	#(PF_COLOR, "white",  "White point color",  (255,255,255) ),
	#(PF_COLOR, "gray",  "Gray point color",  (128,128,128) )
	#(PF_FILE, "infilename", "Temp Filepath", "/Default/Path")
	#(PF_DIRNAME, "source_directory", "Source Directory", "") for some reason, on my computer when i(Tin) use PF_DIRNAME the pythonw.exe would crash
	],
	[],
	python_glow)

main()
